/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-maggie-motor-controller-msgs-0.0.2-0raring-20150414-0506/srv/Configuration.srv
 *
 */


#ifndef MAGGIE_MOTOR_CONTROLLER_MSGS_MESSAGE_CONFIGURATIONREQUEST_H
#define MAGGIE_MOTOR_CONTROLLER_MSGS_MESSAGE_CONFIGURATIONREQUEST_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace maggie_motor_controller_msgs
{
template <class ContainerAllocator>
struct ConfigurationRequest_
{
  typedef ConfigurationRequest_<ContainerAllocator> Type;

  ConfigurationRequest_()
    : max_pos(0.0)
    , min_pos(0.0)
    , max_vel(0.0)
    , max_acc(0.0)
    , max_dec(0.0)
    , cur(0.0)
    , max_cur_lim(0.0)
    , home(0.0)  {
    }
  ConfigurationRequest_(const ContainerAllocator& _alloc)
    : max_pos(0.0)
    , min_pos(0.0)
    , max_vel(0.0)
    , max_acc(0.0)
    , max_dec(0.0)
    , cur(0.0)
    , max_cur_lim(0.0)
    , home(0.0)  {
    }



   typedef float _max_pos_type;
  _max_pos_type max_pos;

   typedef float _min_pos_type;
  _min_pos_type min_pos;

   typedef float _max_vel_type;
  _max_vel_type max_vel;

   typedef float _max_acc_type;
  _max_acc_type max_acc;

   typedef float _max_dec_type;
  _max_dec_type max_dec;

   typedef float _cur_type;
  _cur_type cur;

   typedef float _max_cur_lim_type;
  _max_cur_lim_type max_cur_lim;

   typedef float _home_type;
  _home_type home;




  typedef boost::shared_ptr< ::maggie_motor_controller_msgs::ConfigurationRequest_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::maggie_motor_controller_msgs::ConfigurationRequest_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct ConfigurationRequest_

typedef ::maggie_motor_controller_msgs::ConfigurationRequest_<std::allocator<void> > ConfigurationRequest;

typedef boost::shared_ptr< ::maggie_motor_controller_msgs::ConfigurationRequest > ConfigurationRequestPtr;
typedef boost::shared_ptr< ::maggie_motor_controller_msgs::ConfigurationRequest const> ConfigurationRequestConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::maggie_motor_controller_msgs::ConfigurationRequest_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::maggie_motor_controller_msgs::ConfigurationRequest_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace maggie_motor_controller_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'maggie_motor_controller_msgs': ['/tmp/buildd/ros-hydro-maggie-motor-controller-msgs-0.0.2-0raring-20150414-0506/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::maggie_motor_controller_msgs::ConfigurationRequest_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::maggie_motor_controller_msgs::ConfigurationRequest_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::maggie_motor_controller_msgs::ConfigurationRequest_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::maggie_motor_controller_msgs::ConfigurationRequest_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::maggie_motor_controller_msgs::ConfigurationRequest_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::maggie_motor_controller_msgs::ConfigurationRequest_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::maggie_motor_controller_msgs::ConfigurationRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "4438835c109b232d6790aed31e836e65";
  }

  static const char* value(const ::maggie_motor_controller_msgs::ConfigurationRequest_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x4438835c109b232dULL;
  static const uint64_t static_value2 = 0x6790aed31e836e65ULL;
};

template<class ContainerAllocator>
struct DataType< ::maggie_motor_controller_msgs::ConfigurationRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "maggie_motor_controller_msgs/ConfigurationRequest";
  }

  static const char* value(const ::maggie_motor_controller_msgs::ConfigurationRequest_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::maggie_motor_controller_msgs::ConfigurationRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "\n\
\n\
\n\
float32 max_pos\n\
float32 min_pos\n\
float32 max_vel\n\
float32 max_acc\n\
float32 max_dec\n\
float32 cur\n\
float32 max_cur_lim\n\
float32 home\n\
";
  }

  static const char* value(const ::maggie_motor_controller_msgs::ConfigurationRequest_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::maggie_motor_controller_msgs::ConfigurationRequest_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.max_pos);
      stream.next(m.min_pos);
      stream.next(m.max_vel);
      stream.next(m.max_acc);
      stream.next(m.max_dec);
      stream.next(m.cur);
      stream.next(m.max_cur_lim);
      stream.next(m.home);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct ConfigurationRequest_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::maggie_motor_controller_msgs::ConfigurationRequest_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::maggie_motor_controller_msgs::ConfigurationRequest_<ContainerAllocator>& v)
  {
    s << indent << "max_pos: ";
    Printer<float>::stream(s, indent + "  ", v.max_pos);
    s << indent << "min_pos: ";
    Printer<float>::stream(s, indent + "  ", v.min_pos);
    s << indent << "max_vel: ";
    Printer<float>::stream(s, indent + "  ", v.max_vel);
    s << indent << "max_acc: ";
    Printer<float>::stream(s, indent + "  ", v.max_acc);
    s << indent << "max_dec: ";
    Printer<float>::stream(s, indent + "  ", v.max_dec);
    s << indent << "cur: ";
    Printer<float>::stream(s, indent + "  ", v.cur);
    s << indent << "max_cur_lim: ";
    Printer<float>::stream(s, indent + "  ", v.max_cur_lim);
    s << indent << "home: ";
    Printer<float>::stream(s, indent + "  ", v.home);
  }
};

} // namespace message_operations
} // namespace ros

#endif // MAGGIE_MOTOR_CONTROLLER_MSGS_MESSAGE_CONFIGURATIONREQUEST_H
