/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-maggie-motor-controller-msgs-0.0.2-0raring-20150414-0506/msg/Odometry.msg
 *
 */


#ifndef MAGGIE_MOTOR_CONTROLLER_MSGS_MESSAGE_ODOMETRY_H
#define MAGGIE_MOTOR_CONTROLLER_MSGS_MESSAGE_ODOMETRY_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace maggie_motor_controller_msgs
{
template <class ContainerAllocator>
struct Odometry_
{
  typedef Odometry_<ContainerAllocator> Type;

  Odometry_()
    : position(0)
    , velocity(0)
    , current(0)  {
    }
  Odometry_(const ContainerAllocator& _alloc)
    : position(0)
    , velocity(0)
    , current(0)  {
    }



   typedef int32_t _position_type;
  _position_type position;

   typedef int32_t _velocity_type;
  _velocity_type velocity;

   typedef int32_t _current_type;
  _current_type current;




  typedef boost::shared_ptr< ::maggie_motor_controller_msgs::Odometry_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::maggie_motor_controller_msgs::Odometry_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct Odometry_

typedef ::maggie_motor_controller_msgs::Odometry_<std::allocator<void> > Odometry;

typedef boost::shared_ptr< ::maggie_motor_controller_msgs::Odometry > OdometryPtr;
typedef boost::shared_ptr< ::maggie_motor_controller_msgs::Odometry const> OdometryConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::maggie_motor_controller_msgs::Odometry_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::maggie_motor_controller_msgs::Odometry_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace maggie_motor_controller_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'maggie_motor_controller_msgs': ['/tmp/buildd/ros-hydro-maggie-motor-controller-msgs-0.0.2-0raring-20150414-0506/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::maggie_motor_controller_msgs::Odometry_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::maggie_motor_controller_msgs::Odometry_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::maggie_motor_controller_msgs::Odometry_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::maggie_motor_controller_msgs::Odometry_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::maggie_motor_controller_msgs::Odometry_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::maggie_motor_controller_msgs::Odometry_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::maggie_motor_controller_msgs::Odometry_<ContainerAllocator> >
{
  static const char* value()
  {
    return "fbb2e26f2b0e785e7afe331fd8d3c42d";
  }

  static const char* value(const ::maggie_motor_controller_msgs::Odometry_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xfbb2e26f2b0e785eULL;
  static const uint64_t static_value2 = 0x7afe331fd8d3c42dULL;
};

template<class ContainerAllocator>
struct DataType< ::maggie_motor_controller_msgs::Odometry_<ContainerAllocator> >
{
  static const char* value()
  {
    return "maggie_motor_controller_msgs/Odometry";
  }

  static const char* value(const ::maggie_motor_controller_msgs::Odometry_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::maggie_motor_controller_msgs::Odometry_<ContainerAllocator> >
{
  static const char* value()
  {
    return "#\n\
# Message for odometry sensors\n\
#\n\
int32 position\n\
int32 velocity\n\
int32 current\n\
";
  }

  static const char* value(const ::maggie_motor_controller_msgs::Odometry_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::maggie_motor_controller_msgs::Odometry_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.position);
      stream.next(m.velocity);
      stream.next(m.current);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct Odometry_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::maggie_motor_controller_msgs::Odometry_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::maggie_motor_controller_msgs::Odometry_<ContainerAllocator>& v)
  {
    s << indent << "position: ";
    Printer<int32_t>::stream(s, indent + "  ", v.position);
    s << indent << "velocity: ";
    Printer<int32_t>::stream(s, indent + "  ", v.velocity);
    s << indent << "current: ";
    Printer<int32_t>::stream(s, indent + "  ", v.current);
  }
};

} // namespace message_operations
} // namespace ros

#endif // MAGGIE_MOTOR_CONTROLLER_MSGS_MESSAGE_ODOMETRY_H
